import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.beans.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.filechooser.*;
import javax.swing.border.*;

public class JavaMapper extends JFrame implements ActionListener,ChangeListener {
    
    public static String version = "0.2";
    public static boolean debug = false;
    
    JFileChooser fileDialog;
    JFileFilter imageFilter,clientFilter,serverFilter;

    FilePreviewer filePreviewer;
    
    MediaTracker mediatracker = new MediaTracker(this);
    
    JMenuBar menuBar;
    // File Menu
    JMenuItem mOpenImage,mOpenMap,mSave,mSaveAs,mClose,mExit;
    // Edit Menu
    JCheckBoxMenuItem mPreview;
    JMenuItem mCopyShape, mDeleteShape, mDeleteAllShapes;
    // Tool Menu
    ButtonGroup toolMenuGroup;
    JRadioButtonMenuItem mRect, mCircle, mPoly, mSelect;

    JButton bDeleteShape;
    JToggleButton bRect, bCircle, bPoly, bSelect;
    // Poly Popup Menu
    JPopupMenu polyPopup;
    JMenuItem mPolyInsert,mPolyDelete;
    // Help Menu
    JMenuItem mAbout;
    
    Vector imageMaps = new Vector();
    JTabbedPane mapPanel;
    ImageMap currentMap;

    String selectedTool;
    ToolMenuListener toolMenuListener = new ToolMenuListener();
    ToolButtonListener toolButtonListener = new ToolButtonListener();
    ButtonListener buttonListener = new ButtonListener();
    PolyListener polyListener = new PolyListener();

    JLabel mouseXY;
    
    static Preview previewFrame;
    Properties properties;
    //public static FileViewer fileviewer;
    
    public JavaMapper() {
	super("JavaMapper");
	
	// filters
	imageFilter = new JFileFilter(new String[] {"jpg", "gif"}, "JPEG & GIF Images");
	clientFilter = new JFileFilter(new String[] {"html","htm"}, "Client-side Map");
	serverFilter = new JFileFilter(new String[] {"map"}, "Server-side Map");
	
	previewFrame = new Preview(this);
	properties = new Properties(this);
	//fileviewer = new FileViewer();
	
	buildMenuBar();
	setJMenuBar(menuBar);
	
	polyPopup = new JPopupMenu();
	
	mPolyInsert = new JMenuItem("Insert Point");
	mPolyInsert.addActionListener(polyListener);
	polyPopup.add(mPolyInsert);
	
	mPolyDelete = new JMenuItem("Delete Point");
	mPolyDelete.addActionListener(polyListener);
	polyPopup.add(mPolyDelete);
	
	getContentPane().add(polyPopup);
	
	getContentPane().setLayout(new BorderLayout());
       
	
	CompoundBorder border = new CompoundBorder(BorderFactory.createEtchedBorder(),new EmptyBorder(new Insets(3,3,3,3)));
	
	bRect = new JToggleButton(new ImageIcon("images/rect.gif"));
	bRect.addItemListener(toolButtonListener);
	bRect.setBorder(border);
	bCircle = new JToggleButton(new ImageIcon("images/circle.gif"));
	bCircle.addItemListener(toolButtonListener);
	bCircle.setBorder(border);
	bPoly = new JToggleButton(new ImageIcon("images/poly.gif"));
	bPoly.addItemListener(toolButtonListener);
	bPoly.setBorder(border);
	bSelect = new JToggleButton(new ImageIcon("images/select.gif"));
	bSelect.addItemListener(toolButtonListener);
	bSelect.setBorder(border);
	
	ButtonGroup toolButtonGroup = new ButtonGroup();
	toolButtonGroup.add(bRect);
	toolButtonGroup.add(bCircle);
	toolButtonGroup.add(bPoly);
	toolButtonGroup.add(bSelect);

	JToolBar buttonBar = new JToolBar();
	buttonBar.add(bRect);
	buttonBar.add(bCircle);
	buttonBar.add(bPoly);
	buttonBar.add(bSelect);
	
	bDeleteShape = new JButton(new ImageIcon("images/delete.gif"));
	bDeleteShape.setBorder(border);
	bDeleteShape.setEnabled(false);
	bDeleteShape.addActionListener(buttonListener);
	buttonBar.add(bDeleteShape);

	JPanel mainPanel = new JPanel(new BorderLayout());
	mainPanel.add("North",buttonBar);
	
	JPanel mapPanelBG = new JPanel();
	mapPanelBG.setLayout(new BorderLayout());
	mapPanelBG.setBackground(new Color(150,150,150));
	
	mapPanel = new JTabbedPane();
	mapPanel.addChangeListener(this);
	mapPanelBG.add("Center",mapPanel);
	
	JSplitPane splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, properties, mapPanelBG);
	mainPanel.add("Center", splitPane);
	
	getContentPane().add("Center", mainPanel);
	
	JToolBar statusBar = new JToolBar();

	mouseXY = new JLabel("x:0 y:0 w: h:     ");
	statusBar.add("West",mouseXY);
	
	getContentPane().add("South",statusBar);
	
	this.addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e) {
		    exit();
		}
		public void windowIconified(WindowEvent e) {
		    if (previewFrame.isVisible()) {
			previewFrame.isShown = true;
			previewFrame.setVisible(false);
		    }
		}
		public void windowDeiconified(WindowEvent e) {
		    if (previewFrame.isShown) {
			previewFrame.isShown = false;
			previewFrame.setVisible(true);
		    }
		}
	    });
	
	setSize(500,380);
	setVisible(true);
	
	mRect.setSelected(true);
	println(" done.");
    }

    private void buildMenuBar() {
	menuBar = new JMenuBar();
	
	// File Menu
	
	mOpenImage = new JMenuItem("Open Image");
	mOpenImage.addActionListener(this);
	mOpenMap = new JMenuItem("Open Imagemap");
	mOpenMap.addActionListener(this);
	mSave = new JMenuItem("Save");
	mSave.addActionListener(this);
	mSave.setEnabled(false);
	mSaveAs = new JMenuItem("Save As...");
	mSaveAs.addActionListener(this);
	mSaveAs.setEnabled(false);
	mClose = new JMenuItem("Close Image");
	mClose.addActionListener(this);
	mClose.setEnabled(false);
	mExit = new JMenuItem("Exit");
	mExit.addActionListener(this);

	JMenu mFile = new JMenu("File");
	mFile.add(mOpenImage);
	mFile.add(mOpenMap);
	mFile.add(mSave);
	mFile.add(mSaveAs);
	mFile.add(mClose);
	mFile.addSeparator();
	mFile.add(mExit);

	menuBar.add(mFile);
	
	// Edit Menu
	
	mCopyShape = new JMenuItem("Copy Shape");
	mCopyShape.addActionListener(this);
	mCopyShape.setEnabled(false);
	mDeleteShape = new JMenuItem("Delete Shape");
	mDeleteShape.addActionListener(this);
	mDeleteShape.setEnabled(false);
	mDeleteAllShapes = new JMenuItem("Delete All Shapes");
	mDeleteAllShapes.addActionListener(this);
	mDeleteAllShapes.setEnabled(false);
	
	mPreview = new JCheckBoxMenuItem("Preview Output");
	mPreview.addActionListener(this);
	
	JMenu mEdit = new JMenu("Edit");
	mEdit.add(mCopyShape);
	mEdit.add(mDeleteShape);
	mEdit.add(mDeleteAllShapes);
	mEdit.addSeparator();
	mEdit.add(mPreview);
	menuBar.add(mEdit);

	// Tool Menu
	
	mRect = new JRadioButtonMenuItem("Rectangle");
	mRect.addItemListener(toolMenuListener);
	mCircle = new JRadioButtonMenuItem("Circle");
	mCircle.addItemListener(toolMenuListener);
	mPoly = new JRadioButtonMenuItem("Polygon");
	mPoly.addItemListener(toolMenuListener);
	mSelect = new JRadioButtonMenuItem("Select Shape");
	mSelect.addItemListener(toolMenuListener);

	JMenu mTool = new JMenu("Tool");
	mTool.add(mRect);
	mTool.add(mCircle);
	mTool.add(mPoly);
	mTool.add(mSelect);
	
	toolMenuGroup = new ButtonGroup();
	toolMenuGroup.add(mRect);
	toolMenuGroup.add(mCircle);
	toolMenuGroup.add(mPoly);
	toolMenuGroup.add(mSelect);

	menuBar.add(mTool);

	// Help Menu

	mAbout = new JMenuItem("About JavaMapper");
	mAbout.addActionListener(this);

	JMenu mHelp = new JMenu("Help");
	mHelp.add(mAbout);
	
	menuBar.add(mHelp);
    }
    
    class ButtonListener implements ActionListener {
	public void actionPerformed(ActionEvent e) {
	    JButton b = (JButton)(e.getSource());
	    if (b==bDeleteShape) currentMap.tool.deleteShape();
	}
    }
    
    public void actionPerformed(ActionEvent e) {
	JMenuItem m = (JMenuItem)(e.getSource());
	String l = m.getLabel();
	if (m==mOpenImage) openImage();
	else if (m==mOpenMap) openMap();
	else if (m==mSave) saveMap();
	else if (m==mSaveAs) saveMapAs();
	else if (m==mClose) closeImage();
	else if (m==mExit) exit();
	else if (m==mDeleteShape) currentMap.tool.deleteShape();
	else if (m==mDeleteAllShapes) currentMap.tool.deleteAllShapes();
	else if (m==mPreview) togglePreview();
	else if (m==mAbout) alert("JavaMapper "+version+
				  "\nhttp://www.dansteinman.com/javamapper/"+
				  "\n\n(C) 1999 Dan Steinman"+
				  "\nDistributable under the terms of the\nGNU General Public License (GPL)."+
				  "\n\nSee the README file included for instructions.");
    }
    
    // Tool Menu Listener
    public class ToolMenuListener implements ItemListener {
	public void itemStateChanged(ItemEvent e) {
	    JRadioButtonMenuItem item = (JRadioButtonMenuItem)(e.getSource());
	    String mode;
	    if (item==mRect) mode = "rect";
	    else if (item==mCircle) mode = "circle";
	    else if (item==mPoly) mode = "poly";
	    else mode = "select";
	    setTool(mode);
	}
    }
    
    // Tool Button Listener
    public class ToolButtonListener implements ItemListener {
	public void itemStateChanged(ItemEvent e) {
	    JToggleButton item = (JToggleButton)(e.getSource());
	    String mode;
	    if (item==bRect) mode = "rect";
	    else if (item==bCircle) mode = "circle";
	    else if (item==bPoly) mode = "poly";
	    else mode = "select";
	    setTool(mode);
	}
    }

    // Tab Listener
    public void stateChanged(ChangeEvent e) {
	currentMap = getCurrentMap();
	if (currentMap!=null) {
	    currentMap.setTool(selectedTool);
	    currentMap.tool.endEverything();
	    properties.index = -1;
	    mSave.setEnabled((currentMap.saveFilePath!=null));
	}
	else {
	    setMenus(false);
	}
	refreshDialogs();
    }
    
    // Poly Insert/Delete Listener
    class PolyListener implements ActionListener {
	public void actionPerformed(ActionEvent e) {
	    JMenuItem m = (JMenuItem)(e.getSource());
	    if (m==mPolyInsert) currentMap.tool.insertPolyPoint();
	    if (m==mPolyDelete) currentMap.tool.deletePolyPoint();
	}
    }
    
    public void setTool(String mode) {
	if (mode == "rect") selectTool(mRect,bRect);
	else if (mode == "circle") selectTool(mCircle,bCircle);
	else if (mode == "poly") selectTool(mPoly,bPoly);
	else if (mode == "select") selectTool(mSelect,bSelect);
	selectedTool = mode;
	if (currentMap!=null) currentMap.setTool(mode);
    }
    
    public void selectTool(JRadioButtonMenuItem m, JToggleButton b) {
	m.removeItemListener(toolMenuListener);
	b.removeItemListener(toolButtonListener);
	if (!b.isSelected()) b.setSelected(true);
	if (!m.isSelected()) m.setSelected(true);
	m.addItemListener(toolMenuListener);
	b.addItemListener(toolButtonListener);
    }
    
    public boolean openImage() {
	fileDialog = new JFileChooser();
	
	filePreviewer = new FilePreviewer(fileDialog);
	fileDialog.addChoosableFileFilter(imageFilter);
	fileDialog.setAccessory(filePreviewer);

	int returnVal = fileDialog.showOpenDialog(this);
	String filepath = "";
	if (returnVal == JFileChooser.APPROVE_OPTION) {
	    filepath = fileDialog.getSelectedFile().getPath();
	    String filetest = filepath.toLowerCase();
	    if (filetest.indexOf(".gif")==-1 && filetest.indexOf(".jpg")==-1 && filetest.indexOf(".jpeg")==-1) {
		alert("Error: not a GIF or JPG file");
		return false;
	    }
	}
	else {
	    return false;
	}
	return loadImage(filepath);
    }

    public boolean loadImage(String imagepath) {
	println("Trying to load "+imagepath);
	File img = new File(imagepath);
	if (!img.exists()) return false;
	Image image = Toolkit.getDefaultToolkit().getImage(imagepath);
	mediatracker.addImage(image,0);
	try {
	    mediatracker.waitForAll();
	}
	catch (Exception e) {
	    alert("Failed to load "+imagepath);
	    return false;
	}
	createNewMap(image, imagepath);
	return true;
    }
    
    public ImageMap getCurrentMap() {
	int i = mapPanel.getSelectedIndex();
	if (i!=-1) return (ImageMap)imageMaps.elementAt(i);
	else return null;
    }
    
    public void createNewMap(Image image, String filepath) {	
	mRect.setSelected(true);
	ImageMap imagemap = new ImageMap(image,filepath,this);
	imageMaps.addElement(imagemap);
	mapPanel.addTab(imagemap.mapName,new JScrollPane(imagemap));
	mapPanel.setSelectedIndex(imageMaps.indexOf(imagemap));
	setMenus(true);
    }

    public void closeImage() {
	Component c = mapPanel.getSelectedComponent();
	int i = mapPanel.getSelectedIndex();
	if (c!=null) {
	    mapPanel.remove(c);
	    imageMaps.removeElementAt(i);
	}
	else {
	    setMenus(false);
	    mSave.setEnabled(false);
	}
	currentMap = getCurrentMap();
	refreshDialogs();
    }
	
    public void setMenus(boolean b) {
	//mRect.setEnabled(b);
	//mCircle.setEnabled(b);
	//mPoly.setEnabled(b);
	//mSelect.setEnabled(b);
	
	mSaveAs.setEnabled(b);
	mClose.setEnabled(b);
    }
	
    public void openMap() {
	fileDialog = new JFileChooser();
	
	fileDialog.addChoosableFileFilter(serverFilter);
	fileDialog.addChoosableFileFilter(clientFilter);

	int returnVal = fileDialog.showOpenDialog(this);
	String filepath = "";
	if (returnVal == JFileChooser.APPROVE_OPTION) {
	    filepath = fileDialog.getSelectedFile().getPath();
	}
	else {
	    return;
	}
	
	if (filepath.indexOf(".map")>0) openServerMap(filepath);
	else openClientMap(filepath);
    }
    
    public void openServerMap(String filepath) {
	String code = readFile(filepath);
	alert("You must now open the image\nthat is associated with this map");
	if (!openImage()) {
	    alert("Error loading imagemap");
	    return;
	}
	
	String lines[] = splitString(code,"\n");
	int count = 0;
	for (int i=0;i<lines.length;i++) {
	    count ++;
	    String line = lines[i];
	    String parts[] = splitString(line," ");
	    String shape = parts[0].toLowerCase();
	    String url = "";
	    int coordStart = 2;
	    if (!line.substring(shape.length()+1,shape.length()+2).equals(" ")) {
		url = parts[1];
	    }
	    else coordStart = 1;
	    if (shape.equals("rect")) {
		String c1 = parts[coordStart];
		String c2 = parts[coordStart+1];
		int x1 = Integer.parseInt(c1.substring(0,c1.indexOf(",")));
		int y1 = Integer.parseInt(c1.substring(c1.indexOf(",")+1));
		int x2 = Integer.parseInt(c2.substring(0,c2.indexOf(",")));
		int y2 = Integer.parseInt(c2.substring(c2.indexOf(",")+1));
		currentMap.tool.createNewRect(x1,y1,x2,y2);
		currentMap.tool.currentShape.setURL(url);
	    }
	    else if (shape.equals("circle")) {
		String c1 = parts[coordStart];
		String c2 = parts[coordStart+1];
		int centerX = Integer.parseInt(c1.substring(0,c1.indexOf(",")));
		int centerY = Integer.parseInt(c1.substring(c1.indexOf(",")+1));
		int y2 = Integer.parseInt(c2.substring(c2.indexOf(",")+1));
		int r = y2-centerY;
		int x1 = centerX-r;
		int x2 = centerX+r;
		int y1 = centerY-r;
		currentMap.tool.createNewCircle(x1,y1,x2,y2);
		currentMap.tool.currentShape.setURL(url);
	    }
	    else if (shape.equals("poly")) {
		Vector x = new Vector();
		Vector y = new Vector();
		for (int j=coordStart;j<parts.length;j++) {
		    String c = parts[j];
		    int x1 = Integer.parseInt(c.substring(0,c.indexOf(",")));
		    int y1 = Integer.parseInt(c.substring(c.indexOf(",")+1));
		    x.addElement(new Integer(x1));
		    y.addElement(new Integer(y1));
		}
		currentMap.tool.createNewPoly(x,y);
		currentMap.tool.currentShape.setURL(url);
	    }
	}
	currentMap.tool.currentShape = null;
	currentMap.saveFilePath = filepath;
	currentMap.saveFileType = "server";
	mSave.setEnabled(true);
	refreshDialogs();
    }

    public String[] splitString(String str, String separator) {
	StringTokenizer tokens = new StringTokenizer(str,separator,false);
	Vector vector = new Vector();
	while (tokens.hasMoreTokens()) {
	    vector.addElement(tokens.nextToken());
	}
	String data[] = new String[vector.size()];
	for (int i=0;i<vector.size();i++) {
	    data[i] = (String)vector.elementAt(i);
	}
	return data;
    }
    
    public void openClientMap(String filepath) {
	String code = readFile(filepath);
	String lines[] = splitString(code,"\n");
	Vector mapNames = new Vector();
	for (int i=0;i<lines.length;i++) {
	    String line = lines[i];
	    line = line.toLowerCase();
	    if (line.substring(0,4).equals("<map")) {
		mapNames.addElement(parseAttribute(line,"name"));
	    }
	}
	if (mapNames.isEmpty()) {
	    alert("No imagemaps were found in this file");
	    return;
	}
	
	if (mapNames.size()==1) {
	    String mapName = (String)mapNames.firstElement();
	    openClientMapNamed(filepath,mapName);
	}
	else {
	    String[] names = new String[mapNames.size()];
	    for (int i=0;i<mapNames.size();i++) {
		String mapName = (String)mapNames.elementAt(i);
		names[i] = mapName;
	    }
	    ListDialog.initialize(this, names, "Imagemap Chooser","Choose the imagemap to edit:","Edit");
	    String selectedName = ListDialog.showDialog(null,names[0]);
	    openClientMapNamed(filepath,selectedName);
	}
    }

    public void openClientMapNamed(String filepath, String mapName) {
	String code = readFile(filepath);
	String lines[] = splitString(code,"\n");
	int start=-1,end=-1;
	String image = "";
	for (int i=0;i<lines.length;i++) {
	    String line = lines[i].toLowerCase();
	    if (line.indexOf("<map")>-1 && line.indexOf(mapName)>-1) {
		start = i+1;
	    }
	    else if (start>-1 && line.indexOf("</map>")>-1) {
		end = i;
	    }
	    else if (line.indexOf("<img")>-1) {
		String usemap = parseAttribute(line,"usemap");
		if (usemap.equals("#"+mapName)) {
		    image = parseAttribute(line,"src");
		}
	    }
	}
	String imagepath = filepath.substring(0,filepath.lastIndexOf("/")+1)+image;
	File img = new File(imagepath);
	boolean loaded = false;
	loaded = loadImage(imagepath);
	if (!loaded) {
	    alert("JavaMapper could not find the image, you\nplease browse for it");
	    loaded = openImage();
	}
	if (!loaded) {
	    alert("Failed to load an image, exiting");
	    return;
	}
	for (int i=start;i<end;i++) {
	    String line = lines[i];
	    String shape = parseAttribute(line,"shape");
	    String name = parseAttribute(line,"name");
	    String url = parseAttribute(line,"href");
	    String coords[] = splitString(parseAttribute(line,"coords"),",");
	    if (shape.equals("rect")) {
		int x1 = Integer.parseInt(coords[0]);
		int y1 = Integer.parseInt(coords[1]);
		int x2 = Integer.parseInt(coords[2]);
		int y2 = Integer.parseInt(coords[3]);
		currentMap.tool.createNewRect(x1,y1,x2,y2);
		currentMap.tool.currentShape.setURL(url);
		if (name!="") currentMap.tool.currentShape.setName(name);
	    }
	    else if (shape.equals("circle")) {
		int centerX = Integer.parseInt(coords[0]);
		int centerY = Integer.parseInt(coords[1]);
		int r = Integer.parseInt(coords[2]);
		int x1 = centerX-r;
		int x2 = centerX+r;
		int y1 = centerY-r;
		int y2 = centerY+r;
		currentMap.tool.createNewCircle(x1,y1,x2,y2);
		currentMap.tool.currentShape.setURL(url);
		if (name!="") currentMap.tool.currentShape.setName(name);
	    }
	    else if (shape.equals("poly")) {
		Vector x = new Vector();
		Vector y = new Vector();
		for (int j=0;j<coords.length-1;j+=2) {
		    int x1 = Integer.parseInt(coords[j]);
		    int y1 = Integer.parseInt(coords[j+1]);
		    x.addElement(new Integer(x1));
		    y.addElement(new Integer(y1));
		}
		currentMap.tool.createNewPoly(x,y);
		currentMap.tool.currentShape.setURL(url);
		if (name!="") currentMap.tool.currentShape.setName(name);
	    }
	}
	currentMap.tool.currentShape = null;
	currentMap.saveFilePath = filepath;
	currentMap.saveFileType = "client";
	mSave.setEnabled(true);
	refreshDialogs();
    }

    public String parseAttribute(String html, String attribute) {
	String attvalue = "";
	if (html.indexOf(attribute)==-1) return attvalue;
	for (int i=html.indexOf(attribute)+attribute.length()+2;i<html.length();i++) {
	    String letter = html.substring(i,i+1);
	    if (letter.equals("\"") || letter.equals("\'") || letter.equals(">")) break;
	    else attvalue += letter;
	}
	return attvalue;
    }

    

    private void saveMap() {
	if (currentMap.saveFilePath==null) return;
	saveTextFile(currentMap.saveFilePath,currentMap.getCode(currentMap.saveFileType));
    }

    private void saveMapAs() {
	fileDialog = new JFileChooser();
	fileDialog.addChoosableFileFilter(serverFilter);
	fileDialog.addChoosableFileFilter(clientFilter);
	fileDialog.setDialogTitle("Save Imagemap");

	int returnVal = fileDialog.showSaveDialog(this);
	String filepath = "";
	if (returnVal == JFileChooser.APPROVE_OPTION) {
	    filepath = fileDialog.getSelectedFile().getPath();
	}
	
	if (filepath.indexOf(".map")>0) currentMap.saveFileType = "server";
	else currentMap.saveFileType = "client";
	
	saveTextFile(filepath,currentMap.getCode(currentMap.saveFileType));
    }

    public String readFile(String file) {
	String text="",str="";
	try {
	    BufferedReader in = new BufferedReader(new FileReader(file));
	    while((str = in.readLine()) != null) {
		text += str+"\n";
	    }
	} catch (Exception e) {
	    return "";
	}
	return text;
    }    

    public boolean saveTextFile(String filepath, String text) {
	try {
	    FileOutputStream file = new FileOutputStream(filepath);
	    DataOutputStream content = new DataOutputStream(file);
	    content.writeBytes(text);
	    content.close();
	    file.close();
	}
	catch (Exception e) {
	    alert("There was a error writing "+filepath);
	    return false;
	}
	println("successfully wrote file: "+filepath);
	return true;
    }
    
    private void togglePreview() {
	previewFrame.setVisible(!previewFrame.isVisible());
    }
    
    public void refreshDialogs() {
	previewFrame.refresh();
	properties.refresh();
    }
	
    public void alert(String msg) {
	JOptionPane.showMessageDialog(this,msg);
    }

    private void exit() {
	println("Quitting.");
	setVisible(false);
	System.exit(0);
    }
    
    public static void println(String s) {
	print(s+"\n");
    }
    public static void print(String s) {
	if (debug) System.out.print(s);
    }

    public static void main(String[] args) {
	if (args.length>0) {
	    if (args[0].equals("-debug")) {
		debug = true;
	    }
	}
	println("JavaMapper "+version);
	println("Copyright (C) 1999 Dan Steinman\n");
	print("Starting JavaMapper...");
	JavaMapper jm = new JavaMapper();
	jm.debug = debug;
    }

}
