import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;

public class Properties extends JPanel implements ListSelectionListener,FocusListener,ActionListener,ItemListener {
    
    JavaMapper frame;
    boolean isShown;
    
    private JTextField mapName,defaultURL,imagePath,areaname,areaurl;
    private JCheckBox saveNames;
    private JButton setinfo;
    private JList areas;
    int index = -1;
    
    public Properties(JavaMapper frame) {
	super();
	this.frame = frame;
	
	GridBagLayout bag;
	GridBagConstraints c;
	

	JPanel mapInfoPanel = new JPanel();
	mapInfoPanel.setBorder(BorderFactory.createCompoundBorder(
								   BorderFactory.createEmptyBorder(5,5,5,5),
								   mapInfoPanel.getBorder())
				);

	bag = new GridBagLayout();
	c = new GridBagConstraints();
	
	c.fill = GridBagConstraints.HORIZONTAL;
  	c.weightx = 1.0;
	//c.weighty = 1.0;
  	c.gridwidth = GridBagConstraints.REMAINDER;
  	c.anchor = GridBagConstraints.NORTH;

	mapInfoPanel.setLayout(bag);
	
	JLabel lmapName = new JLabel("Map Name: ");
	bag.setConstraints(lmapName,c);
	mapInfoPanel.add(lmapName);
	
	mapName = new JTextField();
	mapName.addFocusListener(this);
	mapName.addActionListener(this);
	bag.setConstraints(mapName,c);
	mapInfoPanel.add(mapName);
	
	JLabel ldefaultURL = new JLabel("Default URL: ");
  	bag.setConstraints(ldefaultURL,c);
  	mapInfoPanel.add(ldefaultURL);
	
  	defaultURL = new JTextField();
  	defaultURL.addFocusListener(this);
  	defaultURL.addActionListener(this);
  	bag.setConstraints(defaultURL,c);
  	mapInfoPanel.add(defaultURL);
   
	JLabel limagePath = new JLabel("Image Path: ");
  	bag.setConstraints(limagePath,c);
  	mapInfoPanel.add(limagePath);
	
  	imagePath = new JTextField();
  	imagePath.addFocusListener(this);
  	imagePath.addActionListener(this);
  	bag.setConstraints(imagePath,c);
  	mapInfoPanel.add(imagePath);

  	saveNames = new JCheckBox("save area names");
  	saveNames.addItemListener(this);
	c.weighty = 1.0;
	c.gridheight = GridBagConstraints.REMAINDER;
  	bag.setConstraints(saveNames,c);
  	mapInfoPanel.add(saveNames);

	
	
  	JPanel areaInfoTitle = new JPanel(new BorderLayout());
	areaInfoTitle.setBorder(BorderFactory.createTitledBorder(
								 BorderFactory.createEtchedBorder(),
								 "Area Info")
				);
	
	JPanel areaInfoPanel = new JPanel();
	areaInfoPanel.setBorder(BorderFactory.createCompoundBorder(
								   BorderFactory.createEmptyBorder(5,5,5,5),
								   areaInfoPanel.getBorder())
				);
	areaInfoTitle.add("Center",areaInfoPanel);

  	bag = new GridBagLayout();
  	c = new GridBagConstraints();

	c.fill = GridBagConstraints.HORIZONTAL;
  	c.weightx = 1.0;
  	c.gridwidth = GridBagConstraints.REMAINDER;
	
	areaInfoPanel.setLayout(bag);

	JLabel lareaname = new JLabel("Name");
	bag.setConstraints(lareaname,c);
	areaInfoPanel.add(lareaname);
	
	areaname = new JTextField();
	areaname.setEnabled(false);
	areaname.addFocusListener(this);
	areaname.addActionListener(this);
	bag.setConstraints(areaname,c);
	areaInfoPanel.add(areaname);
	
	JLabel lareaurl = new JLabel("URL");
	bag.setConstraints(lareaurl,c);
	areaInfoPanel.add(lareaurl);
	
	areaurl = new JTextField();
	areaurl.setEnabled(false);
	areaurl.addFocusListener(this);
	areaurl.addActionListener(this);
	bag.setConstraints(areaurl,c);
	areaInfoPanel.add(areaurl);
	

	areas = new JList();
	areas.addListSelectionListener(this);
	JScrollPane areasScroll = new JScrollPane(areas);
	
	JPanel areaInfo = new JPanel(new BorderLayout());
	areaInfo.add("Center",areasScroll);
	areaInfo.add("South",areaInfoPanel);
	
	JTabbedPane tabPane = new JTabbedPane();
	tabPane.addTab("Area Info", areaInfo);
	tabPane.addTab("Map Info", mapInfoPanel);
	
	setLayout(new BorderLayout());
	add("Center",tabPane);
    }
    
    // ListSelectionListener
    public void valueChanged(ListSelectionEvent e) {
	JList list = (JList)(e.getSource());
	int i = list.getSelectedIndex();
	if (i!=-1) {
	    if (index!=-1) {
		if (areaname.getText() != areas.getModel().getElementAt(index)) {
		    setFields();
		}
	    }
	    index = i;
	    frame.setTool("select");
	    areaurl.setText(frame.currentMap.tool.shapes[i].getURL());
	    areaurl.setEnabled(true);
	    areaname.setText(frame.currentMap.tool.shapes[i].getName());
	    areaname.setEnabled(true);
	    frame.currentMap.tool.deselectShape();
	    frame.currentMap.tool.currentShape = frame.currentMap.tool.shapes[i];
	    frame.currentMap.tool.selectShape();
	    frame.currentMap.repaint();
	}
    }
    
    // ActionListener
    public void actionPerformed(ActionEvent e) {
	setFields();
    }
    

    // FocusListener
    public void focusGained(FocusEvent e) {
    }
    public void focusLost(FocusEvent e) {
	setFields();
    }
    
    public void setFields() {
	if (frame.currentMap==null) {
	    clearFields();
	    return;
	}
	
	String name = mapName.getText();
	frame.currentMap.mapName = name;
	if (name.length()==0) name = "untitled";
	frame.mapPanel.setTitleAt(frame.mapPanel.getSelectedIndex(),name);

	frame.currentMap.defaultURL = defaultURL.getText();
	frame.currentMap.imagePath = imagePath.getText();

	if (index!=-1 && index<frame.currentMap.tool.nShapes) {
	    if (frame.currentMap.tool.shapes[index]!=null) {
		if (frame.currentMap.tool.shapes[index].getName() != areaname.getText()) {
		    frame.currentMap.tool.shapes[index].setName(areaname.getText());
		}
		if (frame.currentMap.tool.shapes[index].getURL() != areaurl.getText()) {
		    frame.currentMap.tool.shapes[index].setURL(areaurl.getText());
		}
	    }
	}
	frame.previewFrame.refresh();
    }

    public void clearFields() {
	mapName.setText("");
	defaultURL.setText("");
	imagePath.setText("");
	areaurl.setText("");
	areaurl.setEnabled(false);
	areaname.setText("");
	areaname.setEnabled(false);
	String data[] = new String[0];
	areas.setListData(data);
	saveNames.setSelected(false);
    }

    public void refresh() {
	if (frame.currentMap==null) {
	    clearFields();
	    return;
	}

	mapName.setText(frame.currentMap.mapName);
	defaultURL.setText(frame.currentMap.defaultURL);
	imagePath.setText(frame.currentMap.imagePath);
	saveNames.setSelected(frame.currentMap.saveNames);
	
	frame.currentMap.tool.remakeShapes();
	String data[] = new String[frame.currentMap.tool.nShapes];
	for (int i=0;i<frame.currentMap.tool.nShapes;i++) {
	    data[i] = frame.currentMap.tool.shapes[i].getName();
	}
	areas.removeListSelectionListener(this);
	areas.setListData(data);
	areas.addListSelectionListener(this);
	int i = frame.currentMap.tool.getSelectedIndex();
	if (i!=-1 && frame.currentMap.toolMode=="select") {
	    areas.setSelectedIndex(i);
	    areaurl.setText(frame.currentMap.tool.shapes[i].getURL());
	    areaurl.setEnabled(true);
	    areaname.setText(frame.currentMap.tool.shapes[i].getName());
	    areaname.setEnabled(true);
	    index = i;
	}
	else {
	    areaurl.setText("");
	    areaurl.setEnabled(false);
	    areaname.setText("");
	    areaname.setEnabled(false);
	    index = -1;
	}
    }
    
    // ItemListener
    public void itemStateChanged(ItemEvent e) {
	if (frame.currentMap==null) {
	    return;
	}
	frame.currentMap.saveNames = (e.getStateChange() == ItemEvent.SELECTED);
	frame.previewFrame.refresh();
    }
}
